function [PROBLEM,LOAD] = FIRE_InitAdditionalSetup(PROBLEM,LOAD)

if size(LOAD.IDX.Global.p,1) ~= size(LOAD.IDX.Global.theta,1)
  error('FIRE_InitAdditionalSetup, L.3')
else
  
  dummyVal            = PROBLEM.Solver.ToBC;
  PROBLEM.Solver.ToBC = cell(size(LOAD.IDX.Global.theta,1),1);
  
  for i = 1:size(LOAD.IDX.Global.theta,1)
    
    PROBLEM.Solver.ToBC{i,1} = dummyVal;
    % Setup type of BC for numerical solver
    if PROBLEM.General.LoadType(1) == 1 
      if ~isempty(LOAD.IDX.Dirichlet.theta{i,1})
        PROBLEM.Solver.ToBC{i,1} = 'Dirichlet';
      end
    end
    
    if PROBLEM.General.LoadType(2) == 1
      if ~isempty(LOAD.IDX.Dirichlet.p{i,1})
        PROBLEM.Solver.ToBC{i,1} = 'Dirichlet';
      end
    end

    % Setup Global indexes
    LOAD.IDX.Global.All{i,1} = [LOAD.IDX.Global.p{i,1};LOAD.IDX.Global.theta{i,1}];
  end
end