function [RESP,LOAD] = FIRE_InitField(RESP,LOAD,MatPar)
%% Init transfer pore pressure %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if ~isempty(LOAD.tr_RH)
  LOAD.tr_p        = zeros(size(LOAD.tr_RH));
  LOAD.tr_p(:,1:5) = LOAD.tr_RH(:,1:5);
  
  for i = 6:size(LOAD.tr_RH,2)
    LOAD.tr_p(:,i) = LOAD.tr_RH(:,i).*FIRE_getPSat(LOAD.tr_RH_theta(:,i),1);
    LOAD.tr_p(LOAD.tr_p(:,1)==4,i) = 2.7e3;
  end
else
  LOAD.tr_p = [];
end

%% Init RESP pore pressure field %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
RESP.p(:,1) = RESP.RH(:,1).*FIRE_getPSat(RESP.theta(:,1),1);

