function [OUTPUT,OUTPUT2,PEC,SURFACE] = FIRE_getAlpha(theta,LOAD,ST,MatParVal,TraParVal)

OUTPUT = [];
OUTPUT2 = [];
PEC     = [];
SURFACE = [];

if ~isempty(LOAD.rad_theta)
  OUTPUT   =  zeros(size(LOAD.rad_theta,1),1);
  OUTPUT2  =  zeros(size(LOAD.rad_theta,1),1);
  PEC      = zeros(size(LOAD.rad_theta,1),1);
  SURFACE  = zeros(size(LOAD.rad_theta,1),1);
  
  for i = 1:size(LOAD.rad_theta,1)
    TEMP.Outside        = LOAD.rad_theta(i,ST+5);
    PEC(i,1)            = TEMP.Outside;
    TEMP.Boundary       = mean(theta(LOAD.rad_theta(i,3:4),1));
    SURFACE(i,1)        = TEMP.Boundary ;
    OUTPUT(i,1) = MatParVal(9) * MatParVal(10) * ( (TEMP.Outside + 273.15)^2 + (TEMP.Boundary+ 273.15)^2) * ((TEMP.Outside + 273.15) + (TEMP.Boundary++ 273.15));
    
    if TEMP.Boundary < 100
      OUTPUT2(i,1) = TraParVal(1);
    elseif TEMP.Boundary >= 100 && TEMP.Boundary < 1400
      OUTPUT2(i,1) = TraParVal(1)*(1 + ((TEMP.Boundary-100)/1300)*2); 
    else
      OUTPUT2(i,1) = TraParVal(1)*3;
    end
  
  end
  
end