function [GSM,RHS] = FIRE_getGlobalOp(PROBLEM,MESH,PARAM,GRAD,LOAD,ST,Xn,dXndt)

F = zeros(MESH.Boundary.NoFN*2,1);
I = zeros(3,3);

ID.x = cell(MESH.CElement.NOTriangles,1);
ID.y = cell(MESH.CElement.NOTriangles,1);
ID.s = cell(MESH.CElement.NOTriangles,1);

% C_Check = zeros(MESH.Boundary.NoFN*3, MESH.Boundary.NoFN*3);
% K_Check = zeros(MESH.Boundary.NoFN*3, MESH.Boundary.NoFN*3);

%% MatPar Array
% [1.pSat 2.dpSat 3.wd 4.dwd/dtheta 5.w 6.dw/dp 7.dw/dtheta ...
%    8.hv 9.hd 10.lambda 11.rhos*cs 12.cw 13.kappa]

%% Assembler

for i = 1:MESH.CElement.NOTriangles
  %% Cpp
  Cpp             = ( PARAM.MatPar(i,6) ) * PROBLEM.BF.CSTIFF(:,:,i);
  %% Cpt
  Cpt             = ( PARAM.MatPar(i,7) - PARAM.MatPar(i,4) ) * PROBLEM.BF.CSTIFF(:,:,i);
  %% Ctp
  Ctp             = ( - PARAM.MatPar(i,8) * PARAM.MatPar(i,6) ) * PROBLEM.BF.CSTIFF(:,:,i);
  %% Ctt
  Ctt             = ( PARAM.MatPar(i,11) - PARAM.MatPar(i,8)*PARAM.MatPar(i,7) - PARAM.MatPar(i,9)*PARAM.MatPar(i,4)) * PROBLEM.BF.CSTIFF(:,:,i);
  %% C
  [x,y,ID.s{i,1}] = find([Cpp Cpt; Ctp Ctt]);
  ID.x{i,1}       = (PROBLEM.BF.CN.K(i,x))';
  ID.y{i,1}       = (PROBLEM.BF.CN.K(i,y))';
  
%   C_Check(PROBLEM.BF.CN.K(i,:),PROBLEM.BF.CN.K(i,:)) = C_Check(PROBLEM.BF.CN.K(i,:),PROBLEM.BF.CN.K(i,:)) + [Cww I I; Ctw Ctt I; I I I];
end

C = sparse( cat(1,ID.x{:}), cat(1,ID.y{:}), cat(1,ID.s{:}), MESH.Boundary.NoFN*2, MESH.Boundary.NoFN*2);

%% MatPar Array
% [1.pSat 2.dpSat 3.wd 4.dwd/dtheta 5.w 6.dw/dp 7.dw/dtheta ...
%    8.hv 9.hd 10.lambda 11.rhos*cs 12.cw 13.kappa]

%% Assembler

ID.x = cell(MESH.CElement.NOTriangles,1);
ID.y = cell(MESH.CElement.NOTriangles,1);
ID.s = cell(MESH.CElement.NOTriangles,1);

for i = 1:MESH.CElement.NOTriangles
  %% Kpp
  Kpp             = PARAM.MatPar(i,13) / 9.81 *PROBLEM.BF.BBSTIFF(:,:,i);
  %% Ktt
  Ktt             = PARAM.MatPar(i,10) * PROBLEM.BF.BBSTIFF(:,:,i) ...
    + PARAM.MatPar(i,12) * PARAM.MatPar(i,13) / 9.81 * PROBLEM.BF.N(:,:,i) * GRAD.p(i,:) * PROBLEM.BF.BSTIFF(:,:,i) ;
  %% K
  [x,y,ID.s{i,1}] = find([Kpp I; I Ktt]);
  ID.x{i,1}       = (PROBLEM.BF.CN.K(i,x))';
  ID.y{i,1}       = (PROBLEM.BF.CN.K(i,y))';
  
%   K_Check(PROBLEM.BF.CN.K(i,:),PROBLEM.BF.CN.K(i,:)) = K_Check(PROBLEM.BF.CN.K(i,:),PROBLEM.BF.CN.K(i,:)) + [I I Kwp; I Ktt I; I I I];
end

K = sparse( cat(1,ID.x{:}), cat(1,ID.y{:}), cat(1,ID.s{:}), MESH.Boundary.NoFN*2, MESH.Boundary.NoFN*2);

%% MatPar Array
% [1.pSat 2.dpSat 3.wd 4.dwd/dtheta 5.w 6.dw/dp 7.dw/dtheta ...
%    8.hv 9.hd 10.lambda 11.rhos*cs 12.cw 13.kappa]

%% Assembler

if ~isempty(LOAD.tr_p)
  ID.x = cell(size(LOAD.tr_p,1),1);
  ID.y = cell(size(LOAD.tr_p,1),1);
  ID.s = cell(size(LOAD.tr_p,1),1);

  for i = 1:size(LOAD.tr_p,1)
    %% Kpp
    Kpp = PROBLEM.BF.FSTIFF_P(:,:,i)*PROBLEM.MatPar.TraPar(2);
    
    %% K
    [x,y,ID.s{i,1}] = find(Kpp);
    ID.x{i,1}       = (PROBLEM.BF.CN.tr_p(i,x))';
    ID.y{i,1}       = (PROBLEM.BF.CN.tr_p(i,y))';
    
    %% Fp
    F(PROBLEM.BF.CN.tr_p(i,:),1) = F(PROBLEM.BF.CN.tr_p(i,:),1) + PROBLEM.BF.VSTIFF_P(:,:,i)*PROBLEM.MatPar.TraPar(2)*LOAD.tr_p(i,ST+5);
  end
  
  K = K + sparse( cat(1,ID.x{:}), cat(1,ID.y{:}), cat(1,ID.s{:}), MESH.Boundary.NoFN*2, MESH.Boundary.NoFN*2);
end

%% MatPar Array
% [1.pSat 2.dpSat 3.wd 4.dwd/dtheta 5.w 6.dw/dp 7.dw/dtheta ...
%    8.hv 9.hd 10.lambda 11.rhos*cs 12.cw 13.kappa]

%% Assembler

if ~isempty(LOAD.tr_theta)
  ID.x = cell(size(LOAD.tr_theta,1),1);
  ID.y = cell(size(LOAD.tr_theta,1),1);
  ID.s = cell(size(LOAD.tr_theta,1),1);

  for i = 1:size(LOAD.tr_theta,1)
    %% Ktt
    Ktt = PROBLEM.BF.FSTIFF_T(:,:,i)*PROBLEM.MatPar.TraPar(1);
    
    %% K
    [x,y,ID.s{i,1}] = find(Ktt);
    ID.x{i,1}       = (PROBLEM.BF.CN.tr_theta(i,x))';
    ID.y{i,1}       = (PROBLEM.BF.CN.tr_theta(i,y))';
    
    %% Ft _ transfer
    F(PROBLEM.BF.CN.tr_theta(i,:),1) = F(PROBLEM.BF.CN.tr_theta(i,:),1) + PROBLEM.BF.VSTIFF_T(:,:,i)*PROBLEM.MatPar.TraPar(1)*LOAD.tr_theta(i,ST+5);
  end
  
  clear Ktt;
  
  K = K + sparse( cat(1,ID.x{:}), cat(1,ID.y{:}), cat(1,ID.s{:}), MESH.Boundary.NoFN*2, MESH.Boundary.NoFN*2);
end

%% MatPar Array
% [1.pSat 2.dpSat 3.wd 4.dwd/dtheta 5.w 6.dw/dp 7.dw/dtheta ...
%    8.hv 9.hd 10.lambda 11.rhos*cs 12.cw 13.kappa]

%% Assembler

if ~isempty(LOAD.rad_theta)
  ID.x = cell(size(LOAD.rad_theta,1),1);
  ID.y = cell(size(LOAD.rad_theta,1),1);
  ID.s = cell(size(LOAD.rad_theta,1),1);

  for i = 1:size(LOAD.rad_theta,1)
    %% Kttr
    Kttr = PROBLEM.BF.FSTIFF_RAD(:,:,i)*PARAM.alfaRad(i,1);
    
    %% K
    [x,y,ID.s{i,1}] = find(Kttr);
    ID.x{i,1}       = (PROBLEM.BF.CN.rad_theta(i,x))';
    ID.y{i,1}       = (PROBLEM.BF.CN.rad_theta(i,y))';
    
    %% Ft _ transfer
    F(PROBLEM.BF.CN.rad_theta(i,:),1) = F(PROBLEM.BF.CN.rad_theta(i,:),1) + PROBLEM.BF.VSTIFF_RAD(:,:,i)*PARAM.alfaRad(i,1)*LOAD.rad_theta(i,ST+5);
  end
  
  clear Ktt;
  
  K = K + sparse( cat(1,ID.x{:}), cat(1,ID.y{:}), cat(1,ID.s{:}), MESH.Boundary.NoFN*2, MESH.Boundary.NoFN*2);
end

  %%
  %%
  %%
  %% GSM
  GSM = ( C + PROBLEM.NST.XI * PROBLEM.NST.dTAU(ST) * K );
  %%
  %%
  %%
  %% RHS
  RHS = PROBLEM.NST.XI * PROBLEM.NST.dTAU(ST) * F + C * ( Xn + PROBLEM.NST.dTAU(ST) * ( 1 - PROBLEM.NST.XI ) * dXndt );
