function [Output] = FIRE_getPSat(TEMP,Value)

Lidx            = find( TEMP < 0 ); 
Hidx            = find( TEMP >= 0 & TEMP <= 374.1500); 
Bidx            = find( TEMP > 374.1500); 

%% pSat
psat            = zeros(numel(TEMP),1);
psat(Lidx,1)    = 611 * exp( 22.44 * TEMP(Lidx,1) ./ ( 272.44 + TEMP(Lidx,1) )); 
psat(Hidx,1)    = 611 * exp( 17.08 * TEMP(Hidx,1) ./ ( 234.18 + TEMP(Hidx,1) )); 
psat(Bidx,1)    = 611 * exp( 17.08 * 374.1500 ./ ( 234.18 + 374.1500 )); 

%% dpSat/dtheta
dpsatdt         = zeros(numel(TEMP),1);
dpsatdt(Lidx,1) =  psat(Lidx,1) * ( 22.44 * 272.44 ) ./ (( TEMP(Lidx,1) + 272.44 ) .^2);
dpsatdt(Hidx,1) =  psat(Hidx,1) * ( 17.08 * 234.18 ) ./ (( TEMP(Hidx,1) + 234.18 ) .^2);
dpsatdt(Bidx,1) =  psat(Bidx,1) * ( 17.08 * 234.18 ) ./ (( 374.1500 + 234.18 ) .^2);

%% Output sort
switch Value
  case 1
    Output = psat;
  case 2
    Output = [psat dpsatdt];
end
