function [p,theta,iPos] = FIRE_getSolution(GSM,RHS,PROBLEM,LOAD,NoFN,ST,nrST)


p      = zeros(NoFN,1);
theta  = zeros(NoFN,1);

switch PROBLEM.Solver.ToBC{ST,1}
  case 'Other'
    iPos   = [1 size(LOAD.IDX.Global.p{ST,1},1) ...
      size(LOAD.IDX.Global.p{ST,1},1)+1 size(LOAD.IDX.Global.p{ST,1},1)+size(LOAD.IDX.Global.theta{ST,1},1)];
  case 'Dirichlet'
    iPos   = [1 size(LOAD.IDX.Global.p{ST,1},1) ...
       size(LOAD.IDX.Global.p{ST,1},1)+1 size(LOAD.IDX.Global.p{ST,1},1)+size(LOAD.IDX.Global.theta{ST,1},1)];
     
    if isempty(nrST)
      % Prescribed temperature
      if ~isempty(LOAD.IDX.Dirichlet.theta{ST,1})
        theta(LOAD.IDX.Dirichlet.theta{ST,1})  = LOAD.theta(:,ST+1);
      end
      
      % Prescribed pressure
      if ~isempty(LOAD.IDX.Dirichlet.p{ST,1})
        p(LOAD.IDX.Dirichlet.p{ST,1}) = LOAD.p(:,ST+1);
      end
      
      % New RHS-vector
      RHS                                   = RHS - GSM * [p; theta];
    end
end

switch PROBLEM.Solver.Type
  case 'PCG'
    CG_SOL = pcg( GSM(LOAD.IDX.Global.All{ST,1},LOAD.IDX.Global.All{ST,1}), RHS(LOAD.IDX.Global.All{ST,1},1), PROBLEM.Solver.Accuracy, PROBLEM.Solver.NoI);
  case 'BiCG'
    CG_SOL = bicgstab( GSM(LOAD.IDX.Global.All{ST,1},LOAD.IDX.Global.All{ST,1}), RHS(LOAD.IDX.Global.All{ST,1},1), PROBLEM.Solver.Accuracy, PROBLEM.Solver.NoI);
  case 'Direct'
    CG_SOL = GSM(LOAD.IDX.Global.All{ST,1},LOAD.IDX.Global.All{ST,1})\RHS(LOAD.IDX.Global.All{ST,1},1);
end

p   (LOAD.IDX.Local.p{ST,1},1)      = CG_SOL(iPos(1):iPos(2));
theta(LOAD.IDX.Local.theta{ST,1},1) = CG_SOL(iPos(3):iPos(4));

if isempty(nrST)
  p = FIRE_getpControl(p);
end


