function [Output,Correction] = FIRE_getStrength(theta,p,strengthGL,MatPar)
%% Init
thetaKelvin    = theta + 273.15;

%% Compressive strength 
EUCode                = [20 100 200 300 400 500 600 700 800 900 1000 1100 1200; 1 1 0.95 0.85 0.75 0.60 0.45 0.30 0.15 0.08 0.04 0.01 0]';
EUCode(:,1)           = EUCode(:,1) + 273.15;
EUCode(:,2)           = EUCode(:,2) * MatPar(14);
Compression           = ones(size(theta,1),1) * MatPar(14);

Idx.st                = (thetaKelvin <= 293.15);
Idx.nd                = (thetaKelvin > 293.15 & thetaKelvin <= 1473.15);
Idx.th                = (thetaKelvin > 1473.15);

Compression(Idx.nd,1) = interp1(EUCode(:,1),EUCode(:,2),thetaKelvin(Idx.nd,1));
Compression(Idx.th,1) = 0;
clear Idx;

Idx                   = strengthGL(:,2) < Compression;
Compression(Idx,1)    = strengthGL(Idx,2);

clear Idx;
%% Tensile strength
Strength       = ones(size(theta,1),1)*MatPar(12);

MultiFactor    = MatPar(13);
Idx.st         = (thetaKelvin <= 373.15);
Idx.nd         = (thetaKelvin > 373.15 & thetaKelvin <= 373.15+MultiFactor);
Idx.th         = (thetaKelvin > 373.15+MultiFactor);

Strength(Idx.nd,1) = (( 373.15+MultiFactor - thetaKelvin(Idx.nd,1) ) / (MultiFactor))*MatPar(12);
Strength(Idx.th,1) = 0;
clear Idx

Idx                = strengthGL(:,1) < Strength;
Strength(Idx,1)    = strengthGL(Idx,1);

% Idx.st         = (thetaKelvin <= 373.15);
% Idx.nd         = (thetaKelvin > 373.15 & thetaKelvin <= 823.15);
% Idx.rd         = (thetaKelvin > 823.15 & thetaKelvin <= 1473.15);
% Idx.th         = (thetaKelvin > 1473.15);
% 
% Strength(Idx.nd,1) = (( 873.15 - thetaKelvin(Idx.nd,1) ) / 500) * MatPar(12);
% Strength(Idx.rd,1) = (( 1473.15 - thetaKelvin(Idx.rd,1) ) / 6500) * MatPar(12);
% Strength(Idx.th,1) = 0;

% Strength(21)
%% Correction factor
Correction = ( MatPar(11) * p ) >= Strength;
%% Output
Output     = [Strength Compression];

