function [RESP] = FIRE_main(PROBLEM,MESH,RESP,LOAD)

%% General information
% 2014 - 2018, Author: Jan Sykora

%% Input 
if nargin == 0
  clc;
  close all;
  clear variables;
  
  run('Input_FiFAC2');
  run('Load_FiFAC2');
  
end

%% Init problem
FIRE_tic            = tic;
[PROBLEM,RESP,LOAD] = FIRE_Init(PROBLEM,MESH,RESP,LOAD);
%% Main part
for ST = 1:PROBLEM.NST.NoS    
  [RESP,LOAD] = FIRE_solveProblem(PROBLEM,MESH,RESP,LOAD,ST);
end

%% Save part
PROBLEM.ElapsedTime = toc(FIRE_tic);
if PROBLEM.General.SaveMode
  %% Only for STRIPE problem
%   NoI  = [28;27;4;33;32;41;42;76;8;7;74;73;90;47;44;43;2;49;25;78;50;52;57;77;55;86;85;84;67;80;72;70;71;];
%   
%   RESPr.dpdt     = RESP.dpdt(NoI,:);
%   RESPr.dthetadt = RESP.dthetadt(NoI,:);
%   RESPr.maxtheta = RESP.maxtheta(NoI,:);
%   RESPr.p        = RESP.p(NoI,:);
%   RESPr.RH       = RESP.RH(NoI,:);
%   RESPr.theta    = RESP.theta(NoI,:);
%   RESPr.SPAL     = RESP.SPAL;
%   RESPr.LastSpal = RESP.LastSpal;
%   
%   RESPr.thetaAll = RESP.theta;
%   RESPr.MESH     = MESH;
%   
%   save(PROBLEM.General.SaveName,'RESPr','-v7.3');
  
  save(PROBLEM.General.SaveName,'RESP','-v7.3');
  
  
end

%% deInit problem
FIRE_deInit();

%% Result
% HeatPlotFun(PROBLEM.Mesh.CElement,PROBLEM.Mesh.CNodes,PROBLEM.Mesh.Boundary,RESP.Temp(:,end),[],2,[],[]);
