function [RESP,LOAD] = FIRE_solveProblem(PROBLEM,MESH,RESP,LOAD,ST)
% if ST == 76
%   ST  
% end
[PARAM]       = FIRE_getMatPar(MESH.CElement,RESP.p(:,ST),RESP.theta(:,ST),RESP.STRENGTH,LOAD,ST,PROBLEM.MatPar.MatConst,PROBLEM.MatPar.TraPar);
[GRAD]        = FIRE_getGrad(MESH.CElement,RESP,PROBLEM.BF,ST);
[GSM,RHS]     = FIRE_getGlobalOp(PROBLEM,MESH,PARAM,GRAD,LOAD,ST,[RESP.p(:,ST);RESP.theta(:,ST)],[RESP.dpdt(:,ST);RESP.dthetadt(:,ST)]);
[p,theta,idx] = FIRE_getSolution(GSM,RHS,PROBLEM,LOAD,MESH.Boundary.NoFN,ST,[]);
[PARAM]       = FIRE_getMatPar(MESH.CElement,p,theta,RESP.STRENGTH,LOAD,ST,PROBLEM.MatPar.MatConst,PROBLEM.MatPar.TraPar);
% NEWTON-RAPHSON %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[nrST]                  = 1;
while PROBLEM.General.Switcher == 0
  [GSM,RHS]                               = FIRE_getGlobalOp(PROBLEM,MESH,PARAM,GRAD,LOAD,ST,[RESP.p(:,ST);RESP.theta(:,ST)],[RESP.dpdt(:,ST);RESP.dthetadt(:,ST)]);
  [VR]                                    = RHS - GSM*[p(:,nrST); theta(:,nrST)];
  [PROBLEM.General.Switcher,PerERR(nrST)] = FIRE_getControl(VR(LOAD.IDX.Global.All{ST,1}),RHS(LOAD.IDX.Global.All{ST,1}),[1e-3 1e-3],idx);
  
  %% Standard S T O P
  if PROBLEM.General.Switcher == 1
    [RESP.p(:,ST+1),RESP.theta(:,ST+1),RESP.RH(:,ST+1),RESP.dpdt(:,ST+1),RESP.dthetadt(:,ST+1),RESP.maxtheta] ...
      = FIRE_getAssign(p(:,nrST),theta(:,nrST),RESP.p(:,ST),RESP.theta(:,ST),RESP.dpdt(:,ST),RESP.dthetadt(:,ST),RESP.maxtheta,PROBLEM.NST.XI,PROBLEM.NST.dTAU(ST));
    PROBLEM.General.Switcher   = 0;

    [RESP.STRENGTH]            = FIRE_getUpMechProp(PARAM.MatPar(:,16:17),RESP.SPAL);
    [RESP.AlphaRad(:,ST+1),RESP.AlphaCon(:,ST+1),RESP.Pec(:,ST+1),RESP.Surface(:,ST+1)] ...
                               = FIRE_getAlpha(theta(:,nrST),LOAD,ST,PROBLEM.MatPar.MatConst,PROBLEM.MatPar.TraPar);
    break; 
  end
  %% Emergency S T O P
  if nrST > 40
    [c,idx] = min(PerERR);
    PerERR(end) = PerERR(idx);
    [RESP.p(:,ST+1),RESP.theta(:,ST+1),RESP.RH(:,ST+1),RESP.dpdt(:,ST+1),RESP.dthetadt(:,ST+1),RESP.maxtheta] ...
      = FIRE_getAssign(p(:,idx),theta(:,idx),RESP.p(:,ST),RESP.theta(:,ST),RESP.dpdt(:,ST),RESP.dthetadt(:,ST),RESP.maxtheta,PROBLEM.NST.XI,PROBLEM.NST.dTAU(ST));
    PROBLEM.General.Switcher   = 0;

    [RESP.STRENGTH]            = FIRE_getUpMechProp(PARAM.MatPar(:,16:17),RESP.SPAL);
    [RESP.AlphaRad(:,ST+1),RESP.AlphaCon(:,ST+1),RESP.Pec(:,ST+1),RESP.Surface(:,ST+1)] ...
                                = FIRE_getAlpha(theta(:,idx),LOAD,ST,PROBLEM.MatPar.MatConst,PROBLEM.MatPar.TraPar);
    break;
  end

  [dp,dtheta]                   = FIRE_getSolution(GSM,VR,PROBLEM,LOAD,MESH.Boundary.NoFN,ST,nrST);
  [p(:,nrST+1),theta(:,nrST+1)] = FIRE_getTempMoist(p(:,nrST),theta(:,nrST),dp,dtheta);
  [PARAM]                       = FIRE_getMatPar(MESH.CElement,p(:,nrST+1),theta(:,nrST+1),RESP.STRENGTH,LOAD,ST,PROBLEM.MatPar.MatConst,PROBLEM.MatPar.TraPar);

  nrST = nrST + 1;
end
%% Display message
if PROBLEM.General.DispMode
  disp(['STEP:>>' sprintf('%06d',ST) ' ' 'ITER:>>' sprintf('%03d',nrST) ' ' 'ERR:>>' sprintf('%f',PerERR(end)) ' SPAL:>>' sprintf('%02.2f',sum(MESH.CElement.Matrix(RESP.SPAL,8))/MESH.Boundary.Area*100)]);
end

