%% General setup
% 0[mm]-33 60[mm]-39 80[mm]-70 100[mm]-77 175[mm]-178 250[mm]-171 300[mm]-87
% Location of FE mesh
PROBLEM.General.MeshName   = 'MESH_coarse.mat';
% Name of output file
PROBLEM.General.SaveName   = 'Resp_FiFAC2.mat';
% SaveMode
PROBLEM.General.SaveMode   = 1;
% General schwitcher, do not edit !!!
PROBLEM.General.Switcher   = 0;
% iCount, do not edit !!!
PROBLEM.General.iCount     = 1;
% Loading type [1.(0/1) Predepsana teplota, 2.(0/1) Predepsany tlak
%               3.(0/1) Teplotni prestup,   4.(0/1) Vlhkostni prestupy
%               5.(0/1) Radiace]                      
PROBLEM.General.LoadType   = [1 1 1 0 1]; 

% Display errors of each iteration
PROBLEM.General.DispMode   = 1; 
%
PROBLEM.General.STOPElem    = [176 187];

%% Solver setup
PROBLEM.Solver.Type           = 'Direct'; % [1-PCG 2-BiCG 3-Direct];
% Accuracy of iterative solver
PROBLEM.Solver.Accuracy       = 1e-6;
% Iteration steps of iterative solver
PROBLEM.Solver.NoI            = 500;
% Type of Boundary Conditions, do not edit !!! %[1-Other 2-Dirichlet]
PROBLEM.Solver.ToBC           = 'Other';

%% Material parameter setup

% Material parameters
% [1.lambda_0,u 2.lambda_0,l 3.c_0,s 4.m_c 5.m_l0 6.theta_0 7.permeability_0 8.rho_s ...
%  9.Stefan-Boltzman constant 10.relative surface emissivity 11.n 12.ft0 13.factor 14.fc0]
PROBLEM.MatPar.MatConst    = [3	3	700.00	400.00	180.00	25.00	4.30E-13	2400.00	5.670367e-8	0.99	0.18	1.50E+06	1000.00 15.0E+06];

% Transfer coefficients [1.(Heat) 2.(Moisture)], do not edit !!!
PROBLEM.MatPar.TraPar      = [25  0.0019];

%% Non-stationary PROBLEM setup
% Number of time steps
NoS                        = [0:10:60*60*3];
PROBLEM.NST.NoS            = numel(NoS)-1;
% XI
PROBLEM.NST.XI             = 0.5;
% Time increment at each step
PROBLEM.NST.dTAU           = zeros(1,PROBLEM.NST.NoS);
for iNos = 1:PROBLEM.NST.NoS
  PROBLEM.NST.dTAU(1,iNos) = NoS(iNos+1)-NoS(iNos);
end
clear NoS iNos
% Type of capacity matrix [1-Diagonal 2-NonDiagonal]
PROBLEM.NST.TypeCMat       = 'Diagonal'; 

%% Mesh setup
MESH                       = load([PROBLEM.General.MeshName]);
